extends Spatial

var speed: float = 8.0
var jump_speed: float = 8.0
var push_force: float = 1.0
var velocity: Vector3 = Vector3()

func _input(event):
	if event.is_action_pressed("ui_cancel"):
		get_tree().quit()

func _process(delta):
	$Label.text = str(PhysicsServer.body_get_direct_state($RigidBody.get_rid()).total_gravity)

	if $RigidBody.translation.y < -5.0:
		$RigidBody.translation = Vector3(0, 10, 0)
		$RigidBody.linear_velocity = Vector3()
	if $KinematicBody.translation.y < -5.0:
		$KinematicBody.translation = Vector3(0, 10, 0)
		velocity = Vector3()
	
	velocity.z = 0.0
	velocity.x = 0.0
	if Input.is_action_pressed("ui_up"):
		velocity.z -= speed
	if Input.is_action_pressed("ui_down"):
		velocity.z += speed
	if Input.is_action_pressed("ui_left"):
		velocity.x -= speed
	if Input.is_action_pressed("ui_right"):
		velocity.x += speed
	
	if $Area2.get_overlapping_bodies().has($KinematicBody):
		velocity.y = max(0.0, velocity.y)
	else:
		velocity += PhysicsServer.body_get_direct_state($KinematicBody.get_rid()).total_gravity * delta
	velocity = $KinematicBody.move_and_slide(velocity, Vector3(0,1,0))
